searchNodes=[{"doc":"This is main api of library. To start simple call iex&gt; LocationSimulator.start() Or start with your config iex&gt; config = LocationSimulator.default_config() iex&gt; config = Map.put(config, :worker, 1) iex&gt; LocationSimulator.start(config)","ref":"LocationSimulator.html","title":"LocationSimulator","type":"module"},{"doc":"Get default config of library.","ref":"LocationSimulator.html#default_config/0","title":"LocationSimulator.default_config/0","type":"function"},{"doc":"Start with default config. In this case, library just uses Logger to log data in every event.","ref":"LocationSimulator.html#start/0","title":"LocationSimulator.start/0","type":"function"},{"doc":"Start with config. The config is a map type. Config has info like: %{ worker : 3 , # number of worker will run event : 100 , # number of GPS events will be trigger for a worker interval : 1000 , # this &amp; random_range used for sleep between GPS events, if value is :infinity worker will run forever (you still stop by return {:stop, reason}) random_range : 0 , # 0 mean no random, other positive will be used for generate extra random sleep time callback : MyCallbackModule # your module will handle data } If you need pass your data to callback module you can add that in the config. The config can be change after every event.","ref":"LocationSimulator.html#start/1","title":"LocationSimulator.start/1","type":"function"},{"doc":"DynamicSupervisor, uses for add worker in runtime. Module uses PartitionSupervisor for starting workers faster.","ref":"LocationSimulator.DynamicSupervisor.html","title":"LocationSimulator.DynamicSupervisor","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"LocationSimulator.DynamicSupervisor.html#child_spec/1","title":"LocationSimulator.DynamicSupervisor.child_spec/1","type":"function"},{"doc":"","ref":"LocationSimulator.DynamicSupervisor.html#start_link/1","title":"LocationSimulator.DynamicSupervisor.start_link/1","type":"function"},{"doc":"","ref":"LocationSimulator.DynamicSupervisor.html#start_simulator/1","title":"LocationSimulator.DynamicSupervisor.start_simulator/1","type":"function"},{"doc":"Callback api is a brigde for worker call your code. Has three callback apis: start/2, event/2, stop/2 All these have 2 parameters is config &amp; state. config includes lib's config and your meta data you need pass to module. state is data that is generated by worker. state is an Elixir map with key: :start_time - Timestamp the worker start. :success - Number of event success. :failed - Number of event failed. :error - Number of event error :gps - GPS data of current state. :stop_time - Timestamp worker done, only in stop callback api. GPS data is map with key: :timestamp - delta time in milisecond from last event. :long - Longitude :lati - Latitude :alti - Altitude Example Please go to example folder in repo","ref":"LocationSimulator.Event.html","title":"LocationSimulator.Event","type":"behaviour"},{"doc":"event callback will be trigger every worker generated a new GPS data. If result is {:stop, reason} the worker will stop working.","ref":"LocationSimulator.Event.html#c:event/2","title":"LocationSimulator.Event.event/2","type":"callback"},{"doc":"start event will be trigger when worker start. In this event gps &amp; :end_time won't exist. result return to worker for success is {:ok, new_config}. new_config will be used for next event. if return {:error, reason} the worker will stop working.","ref":"LocationSimulator.Event.html#c:start/2","title":"LocationSimulator.Event.start/2","type":"callback"},{"doc":"stop will be trigger when worker send enough gps event.","ref":"LocationSimulator.Event.html#c:stop/2","title":"LocationSimulator.Event.stop/2","type":"callback"},{"doc":"Generate a random location. Get next gps from a location.","ref":"LocationSimulator.Gps.html","title":"LocationSimulator.Gps","type":"module"},{"doc":"Gets next location from current location.","ref":"LocationSimulator.Gps.html#generate_next_pos/4","title":"LocationSimulator.Gps.generate_next_pos/4","type":"function"},{"doc":"Generates a random location.","ref":"LocationSimulator.Gps.html#generate_pos/0","title":"LocationSimulator.Gps.generate_pos/0","type":"function"},{"doc":"Default callback for demo &amp; develop. Just get data from LocationSimulator.Worker and print to console (by Logger).","ref":"LocationSimulator.LoggerEvent.html","title":"LocationSimulator.LoggerEvent","type":"module"},{"doc":"Worker is a simulator that use for generating GPS data. Worker will call client follow :callback setting in config. Two start/stop event is used for start or init data and clean if need. event api is used for put GPS data to client. Callbacks are declared in LocationSimulator.Event module.","ref":"LocationSimulator.Worker.html","title":"LocationSimulator.Worker","type":"module"},{"doc":"Generate child spec for supervisor.","ref":"LocationSimulator.Worker.html#child_spec/1","title":"LocationSimulator.Worker.child_spec/1","type":"function"},{"doc":"Entry point of worker, start event will be fired from here. Init some data and go to loop function for generating GPS data. Root GPS data will be generated in this function.","ref":"LocationSimulator.Worker.html#init/1","title":"LocationSimulator.Worker.init/1","type":"function"},{"doc":"Support for starting from supervisor.","ref":"LocationSimulator.Worker.html#start_link/1","title":"LocationSimulator.Worker.start_link/1","type":"function"},{"doc":"Use for simulating location(longitude, latitude) data. Support scalable for test workload.","ref":"readme.html","title":"LocationSimulator","type":"extras"},{"doc":"The library has 3 main part: Supervisor. Lib uses DynamicSupervisor for creating worker from config Worker. Generating GPS with user config Callback module. This is defined by user to handle event from worker Api call flow sequenceDiagram participant CallbackMod participant Worker participant Api participant Sup Api-&gt;&gt;Sup: Start with workers from config Sup-&gt;&gt;Worker: Start GPS generator Worker-&gt;&gt;CallbackMod: call start event Worker-&gt;&gt;CallbackMod: call gps event Worker-&gt;&gt;CallbackMod: call stop event (for in local you need install extension to view flow)","ref":"readme.html#achitecture","title":"LocationSimulator - Achitecture","type":"extras"},{"doc":"Library can be installed by adding location_simulator to your list of dependencies in mix.exs : def deps do [ { :location_simulator , &quot;~&gt; 0.1.3&quot; } ] end If you need to modify source please go to Github and clone repo.","ref":"readme.html#installation","title":"LocationSimulator - Installation","type":"extras"},{"doc":"Start LocationSimulator with default config: LocationSimulator . start ( ) With default config simulator will print to Logger with default config Start with your callback &amp; config: config = %{ worker : 3 , event : 100 , interval : 1000 , random_range : 0 , direciton : :random , callback : MyCallbackModule } LocationSimulator . start ( config ) Simulator support directions: :north, :south, :east, :west, :north_east, :north_west, :south_east, :south_west If :direction is missed or equal :random, simulator will random a direction for each worker.","ref":"readme.html#guide","title":"LocationSimulator - Guide","type":"extras"},{"doc":"Start library in Elixir's shell: mix deps.get iex -S mix iex(1)&gt; LocationSimulator.start() For writing callback module please go to callback_event document.","ref":"readme.html#example","title":"LocationSimulator - Example","type":"extras"}]